#!/bin/bash

lang=de
tstyle='+%d.%m.%Y_%H:%M'
case $LANG in 
	nl*)
		lang=nl
		tstyle='+%d-%m-%Y_%H:%M'
	;;
esac

case $1 in 
	avira)
		ls -lhtr --time-style="$tstyle" /AntiVir/*.vdf | tail -n1 | awk '{print $6}' | sed 's/_/ - /g'  
	;;
	clamav)
		ls -lhtr --time-style="$tstyle" "/var/lib/clamav/" | grep 'c.d$' | tail -n1 | awk '{print $6}' | sed 's/_/ - /g'
	;;
	eset)
		ls -lhtr --time-style="$tstyle" "/var/opt/eset/esets/lib" | grep '.dat$' | tail -n1 | awk '{print $6}' | sed 's/_/ - /g'
	;;
	fsecure)
		ls -lhtr --time-style="$tstyle" "/var/opt/f-secure/fsaua/data/content/aquapacked/" | tail -n1 | awk '{print $6}' | sed 's/_/ - /g'
	;;
	kaspersky)
		kavdir=/var/kl/bases_rd.orig
		mountpoint -q /var/kl/bases_rd && kavdir=/var/kl/bases_rd
		ls -lhtr --time-style="$tstyle" "${kavdir}/" | grep 'kdc$' | tail -n1 | awk '{print $6}' | sed 's/_/ - /g'
	;;
	sophos)
		ls -lhtr --time-style="$tstyle" /opt/sophos-av/lib/sav/  | tail -n1 | awk '{print $6}' | sed 's/_/ - /g'  
	;;
	*)
		if mountpoint -q /opt/desinfect/signatures ; then
			if cat /proc/mounts | grep ' /opt/desinfect/signatures ' | awk '{print $3}' | grep -q cifs ; then
				if [ "$lang" = "de" ] ; then
					echo "Signaturen auf CIFS  -  letzte Updates"
				elif [ "$lang" = "nl" ] ; then
					echo "Signatures op CIFS  -  laatste updates"
				else
					echo "Signatures on CIFS   -    last updated"
				fi
			else
				if [ "$lang" = "de" ] ; then
					echo "Signaturen auf USB   -  letzte Updates"
				elif [ "$lang" = "nl" ] ; then
					echo "Signatures op USB   -  laatste updates"
				else
					echo "Signatures on USB    -    last updated"
				fi
			fi			
		else
			if [ "$lang" = "de" ] ; then
				echo "Signaturen im RAM    -  letzte Updates"
			elif [ "$lang" = "nl" ] ; then
				echo "Signatures in RAM   -  laatste updates"
			else
				echo "Signatures in memory   -  last updated"
			fi
		fi
	;;
esac


