#!/usr/bin/ruby
# encoding: utf-8

require 'glib2'
require 'gtk2'
require 'vte'
require "rexml/document"

$scan_running = false
$signatures_ok = false

system("sudo /opt/desinfect/mount_all.rb mount ro") 

LOCSTRINGS = {
	"de" => {
		"error" => "Fehler",
		"virus_found" => "Virus gefunden",
		"virus_found2" => "Es wurden infizierte Dateien gefunden. Wie möchten Sie vorgehen?", 
		"desktop" => "In den Desktop-Modus wechseln",
		"teamviewer" => "TeamViewer öffnen",
		"shutdown" => "Den Computer ausschalten",
		"listvirus" => "Schädlingsliste anzeigen",
		"novirus" => "Kein Virus gefunden",
		"rename" => "Alle potentiellen Schädlinge umbenennen",
		"novirus2" => "Es wurden <b>keine</b> infizierten Dateien gefunden. Wie möchten Sie vorgehen?", 
		"counting" => "Zähle Dateien...",
		"counted" => "FILECOUNT Dateien gefunden",
		"updating" => "Aktualisiere Signaturen",
		"scandone" => "Scan abgeschlossen",
		"scansince" => "Vergangene Scan-Zeit:",
		"scanremain" => "Verbleibende Scan-Zeit:",
		"vircount" => "Virenfunde:",
		"startscan" => "Scan wird gestartet...",
		"calctime" => "Zeit wird berechnet...",
		"none" => "keine",
		"netwait" => "Warte auf Netzwerk...",
		"updatefail" => "Die Aktualisierung der Virensignaturen ist fehlgeschlagen. Bitte stellen Sie jetzt eine Internetverbindung her. Sollte ein erneuter Versuch ebenfalls fehlschlagen, wird mit den vorhandenen älteren Signaturen fortgefahren.",
		"wintitle" => "Desinfec't Easy Scan",
		"analyze_logs" => "Analysiere Logdateien",
		"start" => "Bitte starten",
		"play_games" => "Spiele öffnen"
	},
	"nl" => {
		"error" => "Fout",
		"virus_found" => "Virus gevonden",
		"virus_found2" => "Er zijn besmette bestanden gevonden. Wat wil je doen?",
		"desktop" => "Naar desktop-modus switchen",
		"teamviewer" => "TeamViewer openen",
		"shutdown" => "Computer uitschakelen",
		"listvirus" => "Overzicht van malware tonen",
		"novirus" => "Geen virus gevonden",
		"rename" => "Alle potentiële malware hernoemen",
		"novirus2" => "Er zijn <b>geen</b> besmette bestanden gevonden. Wat wil je doen?", 
		"counting" => "Bestanden tellen...",
		"counted" => "FILECOUNT bestand(en) gevonden",
		"updating" => "Signatures bijwerken",
		"scandone" => "Scannen voltooid",
		"scansince" => "Verlopen scantijd:",
		"scanremain" => "Resterende scantijd:",
		"vircount" => "Gevonden virussen:",
		"startscan" => "Scannen starten...",
		"calctime" => "Tijd berekenen...",
		"none" => "geen",
		"netwait" => "Op netwerk wachten...",
		"updatefail" => "De signatures zijn niet bijgewerkt. Maak verbinding met internet. Als een nieuwe poging weer mislukt, wordt met de geïnstalleerde oudere signatures gescand.",
		"wintitle" => "Desinfec't Easy Scan",
		"analyze_logs" => "Logbestanden analyseren",
		"start" => "Starten",
		"play_games" => "Open games" 
	}
}

def get_trans(id) 
	lang = ENV["LANG"][0..1] 
	return id unless LOCSTRINGS.has_key? lang
	return id unless LOCSTRINGS[lang].has_key? id
	return LOCSTRINGS[lang][id] 
end


def confirm_error(text)
        dialog = Gtk::Dialog.new(
                get_trans("error"),
                $mainwindow,
                Gtk::Dialog::MODAL,
                [ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ]
        )
        dialog.default_response = Gtk::Dialog::RESPONSE_OK
        dialog.has_separator = false
        label = Gtk::Label.new
        label.set_markup(text)
        label.wrap = true
        image = Gtk::Image.new(Gtk::Stock::DIALOG_ERROR, Gtk::IconSize::DIALOG)
        hbox = Gtk::HBox.new(false, 5)
        hbox.border_width = 10
        hbox.pack_start_defaults(image)
        hbox.pack_start_defaults(label)
        dialog.vbox.add(hbox)
        dialog.show_all
        dialog.run { |resp|
                dialog.destroy
                return true
        }
end

def question_dialog(title, text, default=false)
		dialog = Gtk::Dialog.new(
			title,
			$mainwindow,
			Gtk::Dialog::MODAL,
			[ Gtk::Stock::YES, Gtk::Dialog::RESPONSE_YES ],
			[ Gtk::Stock::NO, Gtk::Dialog::RESPONSE_NO ]
		)
		if default == true
			dialog.default_response = Gtk::Dialog::RESPONSE_YES
		else
			dialog.default_response = Gtk::Dialog::RESPONSE_NO
		end
		dialog.has_separator = false
		label = Gtk::Label.new
		label.set_markup(text)
		label.wrap = true
		image = Gtk::Image.new(Gtk::Stock::DIALOG_WARNING, Gtk::IconSize::DIALOG)
		hbox = Gtk::HBox.new(false, 5)
		hbox.border_width = 10
		hbox.pack_start_defaults(image)
		hbox.pack_start_defaults(label)
		dialog.vbox.add(hbox)
		dialog.show_all
		dialog.run { |resp|
			case resp
			when Gtk::Dialog::RESPONSE_YES
				dialog.destroy
				return true
			else
				dialog.destroy
				return false
			end
		}
	end

def show_virus_choice
	dialog = Gtk::Dialog.new(
                get_trans("virus_found"),
                $mainwindow,
                Gtk::Dialog::MODAL,
                [ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ]
        )
        dialog.default_response = Gtk::Dialog::RESPONSE_OK
        dialog.has_separator = false
        label = Gtk::Label.new
        label.set_markup(get_trans("virus_found2"))
        label.wrap = true
        # layoutvbox = Gtk::VBox.new(false, 5)
	# image = Gtk::Image.new(Gtk::Stock::DIALOG_ERROR, Gtk::IconSize::DIALOG)
        # hbox = Gtk::HBox.new(false, 5)
        # hbox.border_width = 10
        # hbox.pack_start_defaults(image)
        # hbox.pack_start_defaults(label)
        dialog.vbox.pack_start_defaults(label)
	desktop = Gtk::RadioButton.new(get_trans("desktop"))
	teamviewer = Gtk::RadioButton.new(desktop, get_trans("teamviewer"))
	poweroff = Gtk::RadioButton.new(desktop, get_trans("shutdown"))
	[ desktop, teamviewer, poweroff].each { |w|  dialog.vbox.pack_start_defaults(w) }
        teamviewer.active = true 
	dialog.show_all
        dialog.run { |resp|
		if teamviewer.active? 
			system("su desinfect -c 'teamviewer.sh' &")
		elsif desktop.active?
			# Gtk.main_quit
			exit 0
		else 
			system("sudo /sbin/poweroff") 
		end
                # dialog.destroy
                # return true
        }
end

def show_clean_choice
	dialog = Gtk::Dialog.new(
                get_trans("novirus"),
                $mainwindow,
                Gtk::Dialog::MODAL,
                [ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ]
        )
        dialog.default_response = Gtk::Dialog::RESPONSE_OK
        dialog.has_separator = false
        label = Gtk::Label.new
        label.set_markup(get_trans("novirus2"))
        label.wrap = true
        # layoutvbox = Gtk::VBox.new(false, 5)
	# image = Gtk::Image.new(Gtk::Stock::DIALOG_ERROR, Gtk::IconSize::DIALOG)
        # hbox = Gtk::HBox.new(false, 5)
        # hbox.border_width = 10
        # hbox.pack_start_defaults(image)
        # hbox.pack_start_defaults(label)
        dialog.vbox.pack_start_defaults(label)
	desktop = Gtk::RadioButton.new(get_trans("desktop"))
	# teamviewer = Gtk::RadioButton.new(desktop, "TeamViewer öffnen")
	poweroff = Gtk::RadioButton.new(desktop, get_trans("shutdown"))
	[ desktop, poweroff].each { |w|  dialog.vbox.pack_start_defaults(w) }
	poweroff.active = true
        dialog.show_all
        dialog.run { |resp|
		#if teamviewer.active? 
		#	system("teamviewer.sh &")
		if desktop.active?
			# Gtk.main_quit
			exit 0
		else 
			system("sudo /sbin/poweroff") 
		end
                # dialog.destroy
                # return true
        }
end

def run_command(pgbar, command, args, text)
        puts "Running " + command + " : " + args.join(" ")  
        pgbar.text = text 
        vte = Vte::Terminal.new
        running = true
        vte.signal_connect("child_exited") { running = false }
        vte.fork_command(command, args)
        while running == true
                pgbar.pulse
                while (Gtk.events_pending?)
                        Gtk.main_iteration
                end
                sleep 0.2 
        end
end

def count_files(pgbar)
	last_pulse = Time.now.to_f
	pgbar.pulse
	file_count = 0
	pgbar.text = get_trans("counting") 
	IO.popen("find -P /media -type f") { |line|
		while line.gets
			file_count += 1
			now = Time.now.to_f
			if (now - last_pulse > 0.2) 
				last_pulse = now
				pgbar.pulse
				pgbar.text = get_trans("counted").gsub("FILECOUNT", file_count.to_s) 
				while (Gtk.events_pending?)
					Gtk.main_iteration
				end
			end
		end
	}
	return file_count
end

def update_signatures(pgbar) 
	while (Gtk.events_pending?)
		Gtk.main_iteration
	end
	today = ` date "+%Y%m%d" `.strip 
	pgbar.text = get_trans("updating") 
	vte = Vte::Terminal.new
	scan_running = true
	vte.signal_connect("child_exited") {
		scan_running = false
	}
	current_pid = vte.fork_command("/bin/bash", [ "/bin/bash", "/opt/desinfect/update_avira.sh" ])
	puts current_pid.to_s 
	while scan_running == true
		pgbar.pulse
		while (Gtk.events_pending?)
			Gtk.main_iteration
		end
		sleep 0.2
	end
	newest_mod = 0
	Dir.entries("/AntiVir").each { |f|
		if f =~ /\.vdf$/ 
			t = File.mtime("/AntiVir/#{f}").to_i
			newest_mod = t if t > newest_mod 
		end
	}
	return true if (Time.now.to_i - newest_mod < 21600 ) 
	return false
end

def run_scan(pgbar, total_files, donetime, remtime, viruslabel, window)
	starttime = Time.now.to_i
	$scan_running = true
	virii = 0 
	last_pulse = Time.now.to_f
	pgbar.pulse
	file_count = 0
	pgbar.text = get_trans("startscan") 
	while (Gtk.events_pending?)
		Gtk.main_iteration
	end
	system("mkdir -p /tmp/desinfect_logs")
	IO.popen("/AntiVir/scancl --nolinks -s --heurlevel=3 --showall -l /tmp/desinfect_logs/LOG_avira.log /media") { |line|
		while line.gets
			current_file = $_ 
			# $stderr.puts current_file
			if current_file.strip =~ /^\/media\// 
				current_file = current_file.split("/")[-1] 
				file_count += 1
				now = Time.now.to_f
				hours = (now.to_i - starttime) / 3600
				minutes = ((now.to_i - starttime) % 3600) / 60 
				seconds = (now.to_i - starttime) % 60 
				if (now - last_pulse > 0.2)  
					donetime.text = "#{hours}h #{minutes}m #{seconds}s"
					last_pulse = now
					pgbar.fraction = file_count.to_f / (total_files.to_f + 1.0)
					remsecs = (now - starttime.to_f) * ( 1.0 / pgbar.fraction - 1.0 )
					remhrs = remsecs.to_i / 3600
					remmins = (remsecs.to_i % 3600) / 60
					if (now.to_i - starttime > 60 || pgbar.fraction > 0.05)
						remtime.text = "ca. #{remhrs}h #{remmins}m"
						window.set_title("Desinfec't Easy Scan - #{(pgbar.fraction * 100).to_i}%")
					end
					# $stderr.puts pgbar.fraction 
					infotext = "Scanne: #{current_file.strip}"
					# infotext = "#{infotext} - #{virii} Virenfunde" if virii > 0 
					if virii > 0
						viruslabel.set_markup("<span foreground='red'>#{virii.to_s}</span>") 
					else
						viruslabel.set_markup("<span foreground='green'>#{virii.to_s}</span>")
					end
					pgbar.text = infotext 
					while (Gtk.events_pending?)
						Gtk.main_iteration
					end
				end
			elsif current_file.strip =~  /ALERT\:\s\[(.*?)\]\s(.*?)\s\<<</
				virus = $1
				filename = $2
				virii += 1 unless filename.strip =~ /\.vir$/ 
			end
		end
	}
	pgbar.fraction = 1.0
	pgbar.text = get_trans("scandone") 
	$scan_running = false
	return virii 
end

def kill_scan
	
end

window = Gtk::Window.new
window.signal_connect("delete_event") {
	puts "delete event occurred"
	# if question_dialog("Wirklich abbrechen?", "Wollen Sie den Desinfec't Easy Scan wirklich abbrechen und den Computer ausschalten?")
		system("killall -9 scancl")
		system("sudo /etc/init.d/esets stop")
		system("sudo /etc/init.d/overlays stop")
		system("sudo /sbin/poweroff")
		Gtk.main_quit
		exit 0
	# end
}
window.signal_connect("destroy") {
	puts "destroy event occurred"
	Gtk.main_quit
	exit 0
}

layoutvb = Gtk::VBox.new(false, 5)

# Table for some stats:
stattable = Gtk::Table.new(3,    2,    false)
stattable.attach(Gtk::Label.new(get_trans("scansince") ), 0, 1, 0, 1, Gtk::EXPAND|Gtk::FILL, Gtk::EXPAND|Gtk::FILL, 2, 2)
stattable.attach(Gtk::Label.new(get_trans("scanremain") ), 0, 1, 1, 2, Gtk::EXPAND|Gtk::FILL, Gtk::EXPAND|Gtk::FILL, 2, 2)
stattable.attach(Gtk::Label.new(get_trans("vircount")), 0, 1, 2, 3, Gtk::EXPAND|Gtk::FILL, Gtk::EXPAND|Gtk::FILL, 2, 2)
donetime = Gtk::Label.new(get_trans("startscan"))
remtime = Gtk::Label.new(get_trans("calctime") )
viruslabel = Gtk::Label.new(get_trans("none"))
stattable.attach(donetime, 1, 2, 0, 1, Gtk::EXPAND|Gtk::FILL, Gtk::EXPAND|Gtk::FILL, 2, 2)
stattable.attach(remtime, 1, 2, 1, 2, Gtk::EXPAND|Gtk::FILL, Gtk::EXPAND|Gtk::FILL, 2, 2)
stattable.attach(viruslabel, 1, 2, 2, 3, Gtk::EXPAND|Gtk::FILL, Gtk::EXPAND|Gtk::FILL, 2, 2)

pgbar = Gtk::ProgressBar.new

#### Choice when virus was found
vlabel = Gtk::Label.new
vlabel.set_markup(get_trans("virus_found2"))
vlabel.wrap = true
vvbox = Gtk::VBox.new(false, 3)
vvbox.pack_start_defaults(vlabel)
vdesktop = Gtk::RadioButton.new(get_trans("desktop"))
vviewlist = Gtk::RadioButton.new(vdesktop, get_trans("listvirus"))
vrename = Gtk::RadioButton.new(vdesktop,get_trans("rename"))
vpoweroff = Gtk::RadioButton.new(vdesktop, get_trans("shutdown"))
vdesktop.active = true 
vbutton = Gtk::Button.new("OK") 
[ vdesktop, vviewlist, vrename, vpoweroff, vbutton ].each { |w|  vvbox.pack_start_defaults(w) }

games_button = Gtk::Button.new(get_trans("play_games"))

#### End virus choice

window.signal_connect("show") {
	while (Gtk.events_pending?)
		Gtk.main_iteration
	end
	# button.sensitive = false
	sigupdate = update_signatures(pgbar) 
	# try again - NetworkManager might be late:
	unless sigupdate == true
		pgbar.text = get_trans("netwait")
		0.upto(50) { |n|
			sleep 0.2
			pgbar.pulse
			while (Gtk.events_pending?)
				Gtk.main_iteration
			end
		}
		sigupdate = update_signatures(pgbar) 
	end
	unless sigupdate == true
		confirm_error(get_trans("updatefail"))
		sigupdate = update_signatures(pgbar) 
		# unless sigupdate == true
		#	confirm_error("Die Aktualisierung der Virensignaturen ist fehlgeschlagen. Es wird mit den vorhandenen älteren Signaturen fortgefahren.")
		# end
	end
	total = count_files(pgbar)
	virii = 0
	# button.label = "\"Easy Scan\" abbrechen"
	# button.sensitive = true
	virii = run_scan(pgbar, total, donetime, remtime, viruslabel, window)
	# button.sensitive = false
	$scan_running = false
	window.set_title(get_trans("wintitle"))
	remtime.text = get_trans("scandone") 
	if virii > 0
		viruslabel.set_markup("<span foreground='red'>#{virii.to_s}</span>") 
		run_command(pgbar, "ruby", [ "ruby", "/opt/desinfect/analyze_logs.rb", "avira" ] , get_trans("analyze_logs") )
		system("mkdir -p /tmp/desinfect_logs")
		system("cp -v /tmp/desinfect_logs/metascan.html /tmp/desinfect_logs/easyscan.html") 
		system("cp -v /opt/desinfect/signatures/desinfect_logs/metascan.html /tmp/desinfect_logs/easyscan.html") 
		pgbar.fraction = 1.0
		pgbar.text = "Analyse abgeschlossen"
		# system("su desinfect -c 'firefox file:///tmp/desinfect_logs/easyscan.html' &") 
		# sleep 2.0
		# show_virus_choice
	else
		# show_clean_choice 
	end
	layoutvb.pack_start_defaults vvbox
	vvbox.show_all
	games_button.hide_all 
	if virii < 1
		vlabel.set_markup(get_trans("novirus2"))
		# vdesktop, vviewlist, vrename, vpoweroff
		[ vviewlist, vrename ].each { |w| w.hide_all }
		vpoweroff.active = true
	else
		vdesktop.hide_all 
		vviewlist.active = true 
	end
	vlabel.width_request = 400 
	# button.sensitive = true
}

vbutton.signal_connect("clicked") { 
	# vdesktop, vviewlist, vrename, vpoweroff
	if vviewlist.active? 
		# system("su desinfect -c 'teamviewer.sh' &")
		system("touch /tmp/.showprotocol")
		system("sudo rm /etc/lightdm/lightdm.conf.d/50-openbox.conf")
		system("sudo systemctl restart lightdm") 
		exit 0
	elsif vrename.active?
		system("ruby /opt/desinfect/rename_all.rb")
	elsif vdesktop.active?
		# Gtk.main_quit
		system("touch /tmp/.showprotocol")
		system("sudo rm /etc/lightdm/lightdm.conf.d/50-openbox.conf")
		system("sudo systemctl restart lightdm") 
		exit 0
	else 
		system("sudo /sbin/poweroff") 
	end
}

games_button.signal_connect("clicked") {
	system('su desinfect -c "thunar /tmp/games" &')
}

pgbar.text = get_trans("start") 
# button.label = "\"Easy Scan\" starten"
[ pgbar, games_button ].each { |w| w.width_request = 500 }
layoutvb.pack_start_defaults stattable
layoutvb.pack_start_defaults pgbar
layoutvb.pack_start_defaults games_button

window.border_width = 15
window.window_position = Gtk::Window::POS_CENTER_ALWAYS
window.set_title(get_trans("wintitle"))
window.add layoutvb
# button.grab_focus
window.show_all
# vvbox.hide_all 
Gtk.main
